/*
** ===================================================================
** Nzev souboru   : klavesnice_1_3.c
** Mikrokontroler  : ATmega16
** Popis           : Funkce pro zobrazeni znaku po stisku klavesnice
**
** Autor           : Ondrej Kaller
**                 : Martin Jancik
** ===================================================================
*/

#include <avr/io.h>
#include <stdio.h>
#include <avr/interrupt.h> 			// knihovna potrebna pro preruseni
#include "lcd_h.h"
#include "scancodes.h"				// hlavickovy soubor se scancody klavesnice
#include "delay.c" 					//knihovna na tvorbu delay

#define F_OSC 16000000UL			//definice frekvence krystalu pro fci delay
#define STARTBIT    1			
#define PARITYBIT  10			
#define STOPBIT    11

char retezec[2]; 
unsigned char citac=0,n=0;
char data=0;

unsigned char i,escape=0,endshift=0,shift=0,capslock=0 ;


	
 void dekodovani(char dekodovani )
			
 {	
			 	

 
 									// escape kody ignorujeme
	
	if (dekodovani==0xE0)			// vysilan u specialnich znaku sipka dolu, nahoru apod, vysilane v paru
	{
	escape=1;
	}
	else if (dekodovani==0xF0)		// vysilan vzdy po pusteni klavesnice mimo specialni znaky
	{
	escape=1;
	if(shift==1)
	endshift=1;
	}
	else if (dekodovani==0x60)
	{
	escape=1;
	if(shift==1)
	endshift=1;
	}
	else if (dekodovani==0x61)
	{
	escape=1;
	if(shift==1)
	endshift=1;
	}
	else if (dekodovani==0x6e)
	{
	escape=1;
	if(shift==1)
	endshift=1;
	}
	else if (dekodovani==0x7c) 		// prnt scrn
	{
	escape=1;
	}
	else if (dekodovani==0x7e) 		// scrl lock
	{
	escape=1;
	}
	else if (dekodovani==0x7f)
	{
	escape=1;
	if(shift==1)
	endshift=1;
	}
	
	else if (dekodovani==0x12) 		//levy shift
	{
	escape=0;
		if(endshift==1)
			{
				shift=0;
				endshift=0;
			}
			else
				{
					shift=1;
				}	
	}
	else if (dekodovani==0x59) 		// pravy shift
	{
	escape=0;
	if(endshift==1)
		{
			shift=0;
			endshift=0;
		}
		else
			{
				shift=1;
			}	
	}
	else if (dekodovani==0x58) 		// Caps Lock 3a
	{
	
		if (escape ==1)
				{
					escape=0;
					 if(capslock==0)
						{
							capslock=1;
						}
						else
							{
							capslock=0;
							}	
				}
	}
	

	else 	
			{
			if (escape==0)
				{
					if (shift|capslock)				//kdyz je zmacknuty shift nebo sme v rezimu capslock
					{
						for(i = 0; i<80; i++) 		//80 znaku dekodujeme na klavesnici, specialni znaky ignorujeme
							{	
								if (velke[i][0] == dekodovani)
									{

								sprintf(retezec,"%c", velke[i][1]);
								lcd_puts(retezec);
				
									}
							}
						escape=0;
						endshift=1;
					}
					else
					{	
						for(i = 0; i<80; i++) 		//80 znaku dekodujeme na klavesnici, specialni znaky ignorujeme
							{	
								if (normal[i][0] == dekodovani)
									{

								sprintf(retezec,"%c", normal[i][1]);
								lcd_puts(retezec);
				
									}
		
							}
			
					}	
		
				}	
	
			else 
			escape=0;	
			}
 }	

int main(void)
{
	
	


	GICR |= (1<<INT0);				//povoleni int0
	MCUCR |= (1<<ISC01) ;			// nastaveno na falling edge

	lcd_init(); 					//Inicializace LCD displeje.
	lcd_clrscr(); 					//Smazani obsahu LCD displeje.
		
	lcd_puts("Nacitani znaku:");	// zobrazi text po dobu 2s
	delay_ms(2000);
	lcd_clrscr();

	sei() ;  
		while (1)
			{
				
			}		


		return 0;
}

	

ISR(INT0_vect)
{

	unsigned char testhodin;

	for(testhodin = 0; testhodin<20; testhodin++) 	// testovani moznych zakmitu klavesnice
		{
	
		}
		
		if (bit_is_clear(PIND,PD2)) 				// testovani moznych zakmitu klavesnice
			{

				citac++;

			if (citac==STARTBIT) 					//start bit
				{
					data=0; 						//nuluji data aby mi nezustavaly viset hodnoty
				}
			else if (citac==PARITYBIT) 				//parita
				{
				}
			else if (citac==STOPBIT) 				//stopbit
				{
					citac=0;
					dekodovani(data);

				}

			else
				{
					data= (data >> 1);				//posun data vlevo
				
						if (bit_is_set(PIND,PD7)) 	//kdyz je na vstupu 1
							{	
						
							data = data | 0x80; 	//prida na konec 1
						
							}
							
				}

		}


}
